pwm2v = 1;%8.087/100;

%Remove first data point (always noisy)
acqDataD.time = acqData.time(2:end);
acqDataD.signals(1).values = acqData.signals(1).values(2:end);
acqDataD.signals(2).values = acqData.signals(2).values(2:end);

%Create low pass filter
d1 = designfilt('lowpassiir','DesignMethod','butter', ...
                'FilterOrder',2,'HalfPowerFrequency',3/25);

%Filter noisy discrete derivative output
acqDataD.signals(2).values = filter(d1,acqDataD.signals(2).values);

%Split data for estimation and validation
indHalf = ceil(length(acqDataD.time)/2);
timeEst = acqDataD.time(1:indHalf);

%Estimation data
inputsEst = pwm2v.* acqDataD.signals(1).values(1:indHalf);
outputsEst = acqDataD.signals(2).values(1:indHalf);
figure(1);
subplot(1,2,1)
plot(timeEst, inputsEst)
xlabel('Time (s)')
ylabel('PWM')
ylim([-100 100])
legend('INPUT SIGNAL')
subplot(1,2,2)
plot(timeEst, outputsEst, 'r')
xlabel('Time (s)')
ylabel('Angular Speed (deg/s)')
ylim([-1000 1000])
legend('MEASURED OUTPUT')

%Validation data
inputsVal = pwm2v.* acqDataD.signals(1).values(indHalf+1:end);
timeVal = acqDataD.time(1:length(inputsVal));
outputsVal = acqDataD.signals(2).values(indHalf+1:end);
figure(2);
subplot(1,2,1)
plot(timeVal, inputsVal)
xlabel('Time (s)')
ylabel('PWM')
ylim([-100 100])
legend('INPUT SIGNAL')
subplot(1,2,2)
plot(timeVal, outputsVal, 'r')
xlabel('Time (s)')
ylabel('Angular Speed (deg/s)')
ylim([-1000 1000])
legend('MEASURED OUTPUT')